=== debian/changelog ===
beignet (0.9.3~really.0.8+dfsg-1) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Set Maintainer to "Debian OpenCL Maintainers" with Simon's permission.
  * Add Simon Richter, Rebecca N. Palmer and myself to Uploaders.
  * Repack upstream tarball to remove non-distributable Len(n)a images and
    CC-BY-NC-SA licensed parts from the test suite.  (Closes: #767387)
  * 0001-use-env-to-set-environment-variables-for-GBE_BIN_GEN.patch: New, fix
    FTBFS of "~dfsg" versions in pbuilder etc.
    - Backport patch to 0.8.
  * Import debian/ packaging history into GIT. Add Vcs-* URLs.
  * Update Homepage.

  [ Rebecca N. Palmer ]
  * Build-Depends: clang-3.4, lib{clang,llvm}-3.4-dev.  (Closes: #764930)
  * patches/versioned-llvm-tools: Fix one more unversioned use of clang.
  * Skip-deleted-tests.patch: New. Skip tests removed in the dfsg version.
  * Replace broken pow(n), rootn, erf(c), tgamma.  (Closes: #768090)
  * Document in the description what hardware this version supports.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 19 Nov 2014 19:52:26 +0100

beignet (0.8-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Adjust clang Build-Depends. (Closes: #759933)
    + Thanks to Julian Wollrath for it.
  * Cherry pick upstream patch to fix licensing issue. (Closes: #757395)
    + Thanks to Julian Wollrath for it.
  * Refresh debug patch.

 -- Julián Moreno Patiño <julian@debian.org>  Thu, 11 Sep 2014 10:44:01 -0500
