=== debian/control ===
Source: beignet
Priority: extra
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Simon Richter <sjr@debian.org>,
 Rebecca N. Palmer <rebecca_palmer@zoho.com>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper (>= 9), cmake, pkg-config, python-minimal,
 ocl-icd-dev, ocl-icd-opencl-dev,
 libdrm-dev, libxfixes-dev, libxext-dev,
 llvm-3.4-dev,
 clang-3.4,
 libclang-3.4-dev,
 libgl1-mesa-dev (>= 9) [!kfreebsd-any],
 libegl1-mesa-dev (>= 9) [!kfreebsd-any],
 libgbm-dev (>= 9) [!kfreebsd-any],
 libtinfo-dev
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.freedesktop.org/wiki/Software/Beignet/
Vcs-Git: git://anonscm.debian.org/pkg-opencl/beignet.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-opencl/beignet.git

Package: beignet-dev
Section: libdevel
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64
Depends: beignet (= ${binary:Version}), ${misc:Depends}
Description: Intel OpenCL library
 OpenCL (Open Computing Language) is a multivendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the development files for directly linking against
 the Intel implementation.

Package: beignet
Section: libs
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: beignet0.0.1
Replaces: beignet0.0.1
Provides: opencl-icd
Description: OpenCL library for Intel Ivy Bridge GPUs
 OpenCL (Open Computing Language) is a multivendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the shared library for the Intel implementation.
 .
 This version of the package supports only Ivy Bridge GPUs
 (HD Graphics 2500/4000, Core ix-3xxx); versions supporting new hardware
 will be made available in -backports.
